/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse povparse
#define yylex   povlex
#define yyerror poverror
#define yylval  povlval
#define yychar  povchar
#define yydebug povdebug
#define yynerrs povnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUM = 258,
     STRING = 259,
     KEYWORD = 260,
     SPHERE = 261,
     BOX = 262,
     CYLINDER = 263,
     CONE = 264,
     PLANE = 265,
     TORUS = 266,
     UNION = 267,
     INTERSECTION = 268,
     DIFFERENCE = 269,
     OBJECT = 270,
     INVERSE = 271,
     NAME = 272,
     DECLARE = 273,
     TRANSF = 274,
     MATRIXTRANSF = 275,
     PIGMENT = 276,
     COLOR = 277,
     RGB = 278,
     RGBF = 279,
     IF = 280,
     IFDEF = 281,
     IFNDEF = 282,
     ELSE = 283,
     END = 284,
     WHILE = 285,
     AND = 286,
     OR = 287,
     NOT = 288,
     LE = 289,
     GE = 290,
     EQ = 291,
     NE = 292,
     NEG = 293
   };
#endif
#define NUM 258
#define STRING 259
#define KEYWORD 260
#define SPHERE 261
#define BOX 262
#define CYLINDER 263
#define CONE 264
#define PLANE 265
#define TORUS 266
#define UNION 267
#define INTERSECTION 268
#define DIFFERENCE 269
#define OBJECT 270
#define INVERSE 271
#define NAME 272
#define DECLARE 273
#define TRANSF 274
#define MATRIXTRANSF 275
#define PIGMENT 276
#define COLOR 277
#define RGB 278
#define RGBF 279
#define IF 280
#define IFDEF 281
#define IFNDEF 282
#define ELSE 283
#define END 284
#define WHILE 285
#define AND 286
#define OR 287
#define NOT 288
#define LE 289
#define GE 290
#define EQ 291
#define NE 292
#define NEG 293




/* Copy the first part of user declarations.  */
#line 1 "parse.pov.yy"
 /* -*- c++ -*- */

   /*
    *  This file is part of ff3d - http://www.freefem.org/ff3d
    *  Copyright (C) 2001, 2002, 2003 Stphane Del Pino
    * 
    *  This program is free software; you can redistribute it and/or modify
    *  it under the terms of the GNU General Public License as published by
    *  the Free Software Foundation; either version 2, or (at your option)
    *  any later version.
    * 
    *  This program is distributed in the hope that it will be useful,
    *  but WITHOUT ANY WARRANTY; without even the implied warranty of
    *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    *  GNU General Public License for more details.
    * 
    *  You should have received a copy of the GNU General Public License
    *  along with this program; if not, write to the Free Software Foundation,
    *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
    * 
    *  $Id: parse.pov.yy,v 1.9 2005/01/08 14:48:49 delpinux Exp $
    * 
    */

#define YYDEBUG 1

#include <sstream>

#include <iostream>
#include <stack>
#include <cctype>
#include <string>

#include <parse.pov.hpp>
#include <SceneBox.hpp>

#include <Scene.hpp>

#include <Sphere.hpp>
#include <Cube.hpp>
#include <Cylinder.hpp>
#include <Cone.hpp>
#include <Plane.hpp>
#include <Torus.hpp>

#include <Not.hpp>
#include <Union.hpp>
#include <Intersection.hpp>
#include <Difference.hpp>

#include <stdlib.h>
#include <stdio.h>

#include <POVLexer.hpp>

#include <ErrorHandler.hpp>
#include <Stringify.hpp>

 extern std::vector<std::string> path;       // include files paths
 bool execute = true;

 variable * variables; 
 int nbvariables;

 extern POVLexer* povlexer;

 void yyerror (char* s);
 void declarevar (char* name, char* val);
 void expend(std::string& expendval);

 extern Scene* pScene;
 SceneBox SB;

 enum statement {
   condition,
   loop
 };

 std::stack<bool> ExecStack;
 std::stack<statement> StatementStack;
 std::stack<long int> StreamPosStack;

 bool BoolOp = false; // used if the actual object is a
                      // construction object that belongs
                      // to a boolean operation
 std::stack<bool> BoolOpStack;
 std::stack<std::vector<Object> > OpStack; // Used to store temporarly objects

#define povlex povlexer->povlex



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 93 "parse.pov.yy"
typedef union YYSTYPE {
  real_t val;
  real_t vect[3];
  real_t vect4[4];
  real_t mat[12];
  char* str;
  int integer;
  long int stream_pos;
  parsetrans trans;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 264 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 276 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   492

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  52
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  17
/* YYNRULES -- Number of rules. */
#define YYNRULES  69
/* YYNRULES -- Number of states. */
#define YYNSTATES  230

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   293

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      47,    48,    42,    41,    51,    40,     2,    43,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    50,
      38,    49,    39,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    45,     2,    46,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    44
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    13,    18,    23,    28,
      30,    32,    37,    43,    51,    58,    65,    66,    69,    73,
      77,    80,    88,    96,   104,   114,   126,   134,   135,   142,
     143,   150,   151,   158,   159,   166,   168,   171,   173,   177,
     181,   185,   189,   193,   196,   198,   202,   206,   210,   214,
     218,   222,   226,   230,   233,   237,   263,   271,   274,   278,
     282,   286,   290,   294,   304,   307,   311,   315,   319,   323
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      53,     0,    -1,    -1,    53,    55,    -1,    53,    58,    -1,
      53,    54,    -1,    26,    47,    17,    48,    -1,    27,    47,
      17,    48,    -1,    25,    47,    65,    48,    -1,    28,    -1,
      29,    -1,    30,    47,    65,    48,    -1,    18,    17,    49,
      64,    50,    -1,    18,    17,    49,     6,    45,    17,    46,
      -1,    21,    45,    22,    23,    67,    46,    -1,    21,    45,
      22,    24,    68,    46,    -1,    -1,    57,    56,    -1,    57,
      19,    67,    -1,    57,    20,    66,    -1,    57,    16,    -1,
       6,    45,    67,    51,    64,    57,    46,    -1,    11,    45,
      64,    51,    64,    57,    46,    -1,     7,    45,    67,    51,
      67,    57,    46,    -1,     8,    45,    67,    51,    67,    51,
      64,    57,    46,    -1,     9,    45,    67,    51,    64,    51,
      67,    51,    64,    57,    46,    -1,    10,    45,    67,    51,
      64,    57,    46,    -1,    -1,    12,    45,    59,    63,    57,
      46,    -1,    -1,    13,    45,    60,    63,    57,    46,    -1,
      -1,    14,    45,    61,    63,    57,    46,    -1,    -1,    15,
      45,    62,    58,    57,    46,    -1,    58,    -1,    58,    63,
      -1,     3,    -1,    64,    41,    64,    -1,    64,    40,    64,
      -1,    64,    42,    64,    -1,    64,    43,    64,    -1,    47,
      64,    48,    -1,    40,    64,    -1,    64,    -1,    64,    39,
      64,    -1,    64,    38,    64,    -1,    64,    35,    64,    -1,
      64,    34,    64,    -1,    64,    36,    64,    -1,    64,    37,
      64,    -1,    65,    31,    65,    -1,    65,    32,    65,    -1,
      33,    65,    -1,    47,    65,    48,    -1,    38,    64,    51,
      64,    51,    64,    51,    64,    51,    64,    51,    64,    51,
      64,    51,    64,    51,    64,    51,    64,    51,    64,    51,
      64,    39,    -1,    38,    64,    51,    64,    51,    64,    39,
      -1,    40,    67,    -1,    67,    40,    67,    -1,    67,    41,
      67,    -1,    67,    42,    64,    -1,    67,    43,    64,    -1,
      64,    42,    67,    -1,    38,    64,    51,    64,    51,    64,
      51,    64,    39,    -1,    40,    68,    -1,    68,    40,    68,
      -1,    68,    41,    68,    -1,    68,    42,    64,    -1,    68,
      43,    64,    -1,    64,    42,    68,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   140,   140,   141,   142,   143,   146,   164,   182,   189,
     194,   207,   218,   243,   254,   260,   269,   278,   310,   371,
     404,   432,   463,   494,   527,   559,   592,   623,   623,   659,
     659,   696,   696,   734,   734,   777,   778,   781,   782,   783,
     784,   785,   786,   787,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   804,   823,   828,   833,   838,
     843,   848,   853,   860,   866,   870,   874,   878,   882,   886
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUM", "STRING", "KEYWORD", "SPHERE",
  "BOX", "CYLINDER", "CONE", "PLANE", "TORUS", "UNION", "INTERSECTION",
  "DIFFERENCE", "OBJECT", "INVERSE", "NAME", "DECLARE", "TRANSF",
  "MATRIXTRANSF", "PIGMENT", "COLOR", "RGB", "RGBF", "IF", "IFDEF",
  "IFNDEF", "ELSE", "END", "WHILE", "AND", "OR", "NOT", "LE", "GE", "EQ",
  "NE", "'<'", "'>'", "'-'", "'+'", "'*'", "'/'", "NEG", "'{'", "'}'",
  "'('", "')'", "'='", "';'", "','", "$accept", "input", "iftok",
  "variable", "objref", "modifier", "object", "@1", "@2", "@3", "@4",
  "objects", "exp", "boolexp", "matrix", "vector", "vector4", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    60,    62,
      45,    43,    42,    47,   293,   123,   125,    40,    41,    61,
      59,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    52,    53,    53,    53,    53,    54,    54,    54,    54,
      54,    54,    55,    55,    56,    56,    57,    57,    57,    57,
      57,    58,    58,    58,    58,    58,    58,    59,    58,    60,
      58,    61,    58,    62,    58,    63,    63,    64,    64,    64,
      64,    64,    64,    64,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    66,    67,    67,    67,    67,
      67,    67,    67,    68,    68,    68,    68,    68,    68,    68
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     2,     2,     4,     4,     4,     1,
       1,     4,     5,     7,     6,     6,     0,     2,     3,     3,
       2,     7,     7,     7,     9,    11,     7,     0,     6,     0,
       6,     0,     6,     0,     6,     1,     2,     1,     3,     3,
       3,     3,     3,     2,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,    25,     7,     2,     3,     3,
       3,     3,     3,     9,     2,     3,     3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,    10,     0,
       5,     3,     4,     0,     0,     0,     0,     0,     0,    27,
      29,    31,    33,     0,     0,     0,     0,     0,    37,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    44,     0,     0,
       0,     0,     0,    43,    57,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,     0,    35,    16,    16,    16,    16,     0,     0,    53,
      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     6,     7,    11,     0,    42,    39,    38,    40,    62,
      41,    58,    59,    60,    61,    16,    16,     0,     0,    16,
      40,    16,    36,     0,     0,     0,     0,     0,    12,    54,
      48,    47,    49,    50,    46,    45,    51,    52,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,    28,
      17,    30,    32,    34,     0,     0,    21,    23,    16,     0,
      26,    22,    18,     0,    19,     0,    13,     0,     0,     0,
       0,     0,    56,    24,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,     0,    14,     0,    43,
      64,     0,     0,     0,     0,     0,    15,     0,     0,    40,
      69,    65,    66,    67,    68,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    63,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    55
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,    20,    21,   150,   123,    82,    50,    51,    52,
      53,    83,    42,    58,   164,    43,   184
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -45
static const short int yypact[] =
{
     -45,   203,   -45,   -44,   -42,   -26,    -3,     2,     6,    10,
      18,    36,    38,    -7,   -15,    39,    49,   -45,   -45,    52,
     -45,   -45,   -45,    71,    71,    71,    71,    71,    81,   -45,
     -45,   -45,   -45,    65,    40,   100,   103,    40,   -45,    81,
      71,    81,   164,   -18,   220,   225,   255,   260,    81,   267,
     432,   432,   432,   432,    76,    40,    40,   414,   -27,    50,
      74,   -17,   272,   -45,   -35,   418,    81,    81,    71,    81,
      71,    71,    81,    81,    81,    71,    71,    81,    81,   -45,
      81,    81,   432,   -45,   -45,   -45,   -45,    79,   387,   -45,
     251,    98,    81,    81,    81,    81,    81,    81,    40,    40,
     -45,   -45,   -45,   -45,    81,   -45,   -13,   -13,   -45,   -45,
     -45,   -35,   -35,   -45,   -45,   441,   445,   279,   284,   441,
     -45,   441,   -45,    69,    85,   123,   136,   108,   -45,   -45,
     441,   441,   441,   441,   441,   441,   -45,   -45,   291,   152,
     204,    81,    71,   218,   224,   -45,    71,    88,    87,   -45,
     -45,   -45,   -45,   -45,    90,    81,   -45,   -45,   441,   296,
     -45,   -45,   445,    81,   -45,   111,   -45,   240,   232,    81,
     303,    13,   -45,   -45,   441,    81,    71,    72,   238,   308,
     422,    81,    72,   449,   429,   -45,    81,   -45,   315,   -45,
      51,    72,    72,    72,    81,    81,   -45,   320,    81,   -45,
     -45,    51,    51,   -45,   -45,    81,   327,   332,    81,    81,
     339,   344,    81,    81,   393,   351,   -45,    81,   356,    81,
     363,    81,   368,    81,   375,    81,   380,    81,   437,   -45
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -45,   -45,   -45,   -45,   -45,   -24,     1,   -45,   -45,   -45,
     -45,   -34,   -28,   -21,   -45,    32,   -31
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      49,    23,    22,    24,    98,    99,    57,    72,    73,    57,
      33,    62,    63,    65,    98,    99,    61,    84,    85,    25,
      79,   100,    70,    71,    72,    73,    88,    57,    90,    80,
      69,   103,    34,    74,    89,    91,   176,   177,   106,   107,
     108,   110,    26,    38,   113,   114,   115,    27,   122,   118,
     119,    28,   120,   121,    86,    29,    44,    45,    46,    47,
     124,   125,   126,    30,   130,   131,   132,   133,   134,   135,
      57,    57,    64,    55,    38,    38,   138,   136,   137,    38,
      48,    31,    87,    32,    38,   145,    35,    56,   146,   147,
     148,   139,   140,   194,   195,   143,    36,   144,   101,    37,
     109,   145,   111,   112,   146,   147,   148,   116,   117,    39,
     181,    40,   182,   158,    54,   149,    48,    59,    41,    41,
      60,    48,   102,    41,   127,   154,   163,   167,    41,    98,
      99,   151,   165,   171,   168,   170,   166,     0,     0,   145,
       0,   174,   146,   147,   148,     0,   129,   179,     0,   183,
     178,   190,   145,   188,   189,   146,   147,   148,   197,     0,
     200,   201,   202,   199,   183,   183,   203,   204,   145,   152,
     206,   146,   147,   148,   159,     0,     0,   207,   162,     0,
     210,   211,   153,     0,   214,   215,     0,     0,     0,   218,
       0,   220,     0,   222,     0,   224,     0,   226,   156,   228,
       0,     0,     0,     2,    66,    67,    68,    69,   180,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,     0,
     145,    13,     0,   146,   147,   148,     0,     0,    14,    15,
      16,    17,    18,    19,   145,     0,     0,   146,   147,   148,
     145,     0,     0,   146,   147,   148,     0,     0,   145,     0,
     157,   146,   147,   148,   145,     0,     0,   146,   147,   148,
      70,    71,    72,    73,   160,    70,    71,    72,    73,     0,
     161,    75,     0,     0,     0,     0,    76,     0,   173,   172,
      66,    67,    80,    69,   185,    92,    93,    94,    95,    96,
      97,    66,    67,    80,    69,    70,    71,    72,    73,   105,
      70,    71,    72,    73,     0,     0,    77,    66,    67,    80,
      69,    78,    66,    67,    80,    69,     0,     0,    81,    70,
      71,    72,    73,   104,    66,    67,    80,    69,     0,     0,
     141,    66,    67,    80,    69,   142,    70,    71,    72,    73,
       0,     0,   155,    66,    67,    80,    69,   169,    66,    67,
      80,    69,     0,     0,   175,    66,    67,    80,    69,   186,
      66,    67,    80,    69,     0,     0,   198,    66,    67,    80,
      69,   205,    66,    67,    80,    69,     0,     0,   208,    66,
      67,    80,    69,   209,    66,    67,    80,    69,     0,     0,
     212,    66,    67,    80,    69,   213,    66,    67,    80,    69,
       0,     0,   217,    66,    67,    80,    69,   219,    66,    67,
      80,    69,     0,     0,   221,    66,    67,    80,    69,   223,
      66,    67,    80,    69,     0,     0,   225,    66,    67,    80,
      69,   227,   216,    66,    67,    80,    69,   128,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    92,    93,
      94,    95,    96,    97,    66,    67,    80,    69,    66,    67,
      80,    69,    70,    71,    72,    73,   105,     0,   187,   192,
     193,   194,   195,     0,     0,   196,   229,    66,    67,    80,
      69,    66,    67,    80,    69,    70,    71,    72,    73,    66,
      67,   191,    69
};

static const short int yycheck[] =
{
      28,    45,     1,    45,    31,    32,    34,    42,    43,    37,
      17,    39,    40,    41,    31,    32,    37,    51,    52,    45,
      48,    48,    40,    41,    42,    43,    54,    55,    56,    42,
      43,    48,    47,    51,    55,    56,    23,    24,    66,    67,
      68,    69,    45,     3,    72,    73,    74,    45,    82,    77,
      78,    45,    80,    81,    53,    45,    24,    25,    26,    27,
      84,    85,    86,    45,    92,    93,    94,    95,    96,    97,
      98,    99,    40,    33,     3,     3,   104,    98,    99,     3,
      40,    45,     6,    45,     3,    16,    47,    47,    19,    20,
      21,   115,   116,    42,    43,   119,    47,   121,    48,    47,
      68,    16,    70,    71,    19,    20,    21,    75,    76,    38,
      38,    40,    40,   141,    49,    46,    40,    17,    47,    47,
      17,    40,    48,    47,    45,    17,    38,   155,    47,    31,
      32,    46,    45,    22,   158,   163,    46,    -1,    -1,    16,
      -1,   169,    19,    20,    21,    -1,    48,   175,    -1,   177,
     174,   182,    16,   181,   182,    19,    20,    21,   186,    -1,
     191,   192,   193,   191,   192,   193,   194,   195,    16,    46,
     198,    19,    20,    21,   142,    -1,    -1,   205,   146,    -1,
     208,   209,    46,    -1,   212,   213,    -1,    -1,    -1,   217,
      -1,   219,    -1,   221,    -1,   223,    -1,   225,    46,   227,
      -1,    -1,    -1,     0,    40,    41,    42,    43,   176,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
      16,    18,    -1,    19,    20,    21,    -1,    -1,    25,    26,
      27,    28,    29,    30,    16,    -1,    -1,    19,    20,    21,
      16,    -1,    -1,    19,    20,    21,    -1,    -1,    16,    -1,
      46,    19,    20,    21,    16,    -1,    -1,    19,    20,    21,
      40,    41,    42,    43,    46,    40,    41,    42,    43,    -1,
      46,    51,    -1,    -1,    -1,    -1,    51,    -1,    46,    39,
      40,    41,    42,    43,    46,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    40,    41,    42,    43,    48,
      40,    41,    42,    43,    -1,    -1,    51,    40,    41,    42,
      43,    51,    40,    41,    42,    43,    -1,    -1,    51,    40,
      41,    42,    43,    51,    40,    41,    42,    43,    -1,    -1,
      51,    40,    41,    42,    43,    51,    40,    41,    42,    43,
      -1,    -1,    51,    40,    41,    42,    43,    51,    40,    41,
      42,    43,    -1,    -1,    51,    40,    41,    42,    43,    51,
      40,    41,    42,    43,    -1,    -1,    51,    40,    41,    42,
      43,    51,    40,    41,    42,    43,    -1,    -1,    51,    40,
      41,    42,    43,    51,    40,    41,    42,    43,    -1,    -1,
      51,    40,    41,    42,    43,    51,    40,    41,    42,    43,
      -1,    -1,    51,    40,    41,    42,    43,    51,    40,    41,
      42,    43,    -1,    -1,    51,    40,    41,    42,    43,    51,
      40,    41,    42,    43,    -1,    -1,    51,    40,    41,    42,
      43,    51,    39,    40,    41,    42,    43,    50,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    40,    41,
      42,    43,    40,    41,    42,    43,    48,    -1,    46,    40,
      41,    42,    43,    -1,    -1,    46,    39,    40,    41,    42,
      43,    40,    41,    42,    43,    40,    41,    42,    43,    40,
      41,    42,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    53,     0,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    18,    25,    26,    27,    28,    29,    30,
      54,    55,    58,    45,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    17,    47,    47,    47,    47,     3,    38,
      40,    47,    64,    67,    67,    67,    67,    67,    40,    64,
      59,    60,    61,    62,    49,    33,    47,    64,    65,    17,
      17,    65,    64,    64,    67,    64,    40,    41,    42,    43,
      40,    41,    42,    43,    51,    51,    51,    51,    51,    64,
      42,    51,    58,    63,    63,    63,    58,     6,    64,    65,
      64,    65,    34,    35,    36,    37,    38,    39,    31,    32,
      48,    48,    48,    48,    51,    48,    64,    64,    64,    67,
      64,    67,    67,    64,    64,    64,    67,    67,    64,    64,
      64,    64,    63,    57,    57,    57,    57,    45,    50,    48,
      64,    64,    64,    64,    64,    64,    65,    65,    64,    57,
      57,    51,    51,    57,    57,    16,    19,    20,    21,    46,
      56,    46,    46,    46,    17,    51,    46,    46,    64,    67,
      46,    46,    67,    38,    66,    45,    46,    64,    57,    51,
      64,    22,    39,    46,    64,    51,    23,    24,    57,    64,
      67,    38,    40,    64,    68,    46,    51,    46,    64,    64,
      68,    42,    40,    41,    42,    43,    46,    64,    51,    64,
      68,    68,    68,    64,    64,    51,    64,    64,    51,    51,
      64,    64,    51,    51,    64,    64,    39,    51,    64,    51,
      64,    51,    64,    51,    64,    51,    64,    51,    64,    39
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 141 "parse.pov.yy"
    { std::cerr << '.'; }
    break;

  case 4:
#line 142 "parse.pov.yy"
    { std::cerr << '.'; }
    break;

  case 5:
#line 143 "parse.pov.yy"
    { std::cerr << '.'; }
    break;

  case 6:
#line 146 "parse.pov.yy"
    {
       ExecStack.push(execute);
       StatementStack.push(condition);
       if (execute) {
	 bool defined_var = false;
	 for (int i=0; i<nbvariables; i++) {
	   if ( strcmp(variables[i].name,yyvsp[-1].str) ) {
	     defined_var = true;
	     break;
	   }
	 }
	 if (defined_var) {
	   execute = true;
	 } else {
	   execute = false;
	 }
       }
      }
    break;

  case 7:
#line 164 "parse.pov.yy"
    {
	ExecStack.push(execute);
	StatementStack.push(condition);
	if (execute) {
	  bool defined_var = false;
	  for (int i=0; i<nbvariables; i++) {
	    if ( strcmp(variables[i].name,yyvsp[-1].str) ) {
	      defined_var = true;
	      break;
	    }
	  }
	  if (!defined_var) {
	    execute = true;
	  } else {
	    execute = false;
	  }
	}
      }
    break;

  case 8:
#line 182 "parse.pov.yy"
    {
	ExecStack.push(execute);
	StatementStack.push(condition);
	if (execute) {
	  execute = yyvsp[-1].integer;
	}
      }
    break;

  case 9:
#line 189 "parse.pov.yy"
    {
	if (ExecStack.top()) { // This means that the IF THEN ELSE statment is not to completly ignore
          execute = ! execute;
	}
      }
    break;

  case 10:
#line 194 "parse.pov.yy"
    {
	if (StatementStack.top()==loop) {
	  fferr(1) << __FILE__ << ':' << __LINE__
		   << ": Not implemented\n";
	  std::exit(1);
// 	  if (execute)
// 	    fseek(yyin, StreamPosStack.top(),SEEK_SET);
// 	  StreamPosStack.pop();
	}
	execute = ExecStack.top();
	StatementStack.pop();
	ExecStack.pop();
      }
    break;

  case 11:
#line 207 "parse.pov.yy"
    {
	ExecStack.push(execute);
	StatementStack.push(loop);
	if (execute) {
	  StreamPosStack.push(yyvsp[-3].stream_pos); // To go back to position in file.
	  execute = yyvsp[-1].integer;
	}
      }
    break;

  case 12:
#line 218 "parse.pov.yy"
    {
                if (execute) {
		  std::string varname = yyvsp[-3].str;
		  int varnum = 0;

		  bool found = false;
		  for (int i=0; i<nbvariables; i++)
		    if (varname == variables[i].name) {
		      found = true;
		      varnum = i;
		      if (variables[i].type == 1) { // var was a string
			free(variables[i].val.s);
		      }
		      break;
		    }
		  if (!found) {
		    varnum = nbvariables;
		    nbvariables++;
		    variables = (variable*)realloc(variables, nbvariables);
		  }
		  variables[varnum].name = new char[strlen(yyvsp[-3].str)+1];
		  strcpy(variables[varnum].name, yyvsp[-3].str);
		  variables[varnum].val.d = yyvsp[-1].val;
                }
              }
    break;

  case 13:
#line 243 "parse.pov.yy"
    {
	      if (execute) {
		declarevar(yyvsp[-5].str, yyvsp[-1].str); // not complete
		std::cerr << __FILE__ << ':' << __LINE__
		     << ':' << "Incorrect implementation\n";
		std::exit(1);
	      }
	    }
    break;

  case 14:
#line 255 "parse.pov.yy"
    {
	       for (size_t i=0; i<3; ++i)
		 yyval.vect4[i] = yyvsp[-1].vect[i];
	       yyval.vect4[3] = 0;
	     }
    break;

  case 15:
#line 261 "parse.pov.yy"
    {
	       for (size_t i=0; i<4; ++i)
		 yyval.vect4[i] = yyvsp[-1].vect4[i];
	     }
    break;

  case 16:
#line 269 "parse.pov.yy"
    {
		  if (execute) {
		    yyval.trans.number = 0;
		    yyval.trans.hasRef = false;
		    yyval.trans.inverse = false;
		    for (size_t i=0; i<4; ++i)
		      yyval.trans.ref[i] = 0;
		  }
		}
    break;

  case 17:
#line 279 "parse.pov.yy"
    {
		  if (execute) {
		    yyval.trans.number = yyvsp[-1].trans.number;
		    yyval.trans.type = new TransType[(yyval.trans.number)];
		    yyval.trans.vect[0] = new real_t[(yyval.trans.number)];
		    yyval.trans.vect[1] = new real_t[(yyval.trans.number)];
		    yyval.trans.vect[2] = new real_t[(yyval.trans.number)];

		    for (size_t i=0; i<12; ++i)
		      yyval.trans.mat[i] = yyvsp[-1].trans.mat[i];

		    /* copy old modifier values */
		    for (int i=0; i<yyvsp[-1].trans.number; i++) {
		      yyval.trans.type[i] = yyvsp[-1].trans.type[i];
		      yyval.trans.vect[0][i] = yyvsp[-1].trans.vect[0][i];
		      yyval.trans.vect[1][i] = yyvsp[-1].trans.vect[1][i];
		      yyval.trans.vect[2][i] = yyvsp[-1].trans.vect[2][i];
		    }
		    if (yyvsp[-1].trans.number > 0) {
		      delete[] yyvsp[-1].trans.type; /* deallocate memory if needed */
		      for (int i=0; i<3; i++)
			delete[] yyvsp[-1].trans.vect[i];
		    }
		    yyval.trans.inverse = yyvsp[-1].trans.inverse;

		    yyval.trans.hasRef = true;

		    for (size_t i=0; i<4; ++i)
		      yyval.trans.ref[i] = yyvsp[0].vect4[i];
		  }
		}
    break;

  case 18:
#line 311 "parse.pov.yy"
    {
		  if (execute) {

		    TransType* savetype;
		    real_t* savevect[3];
		  
		    savetype = new TransType[yyval.trans.number+1];
		    for (int i=0; i<3; i++)
		      savevect[i] = new real_t[yyval.trans.number+1];

		    for (int i=0; i<yyval.trans.number; i++) {
		      savetype[i] = yyval.trans.type[i]; /* keeps old values */
		      savevect[0][i] = yyval.trans.vect[0][i];
		      savevect[1][i] = yyval.trans.vect[1][i];
		      savevect[2][i] = yyval.trans.vect[2][i];
		    }

		    if (yyval.trans.number > 0) {
		      delete[] yyval.trans.type; /* deallocate memory if needed */
		      for (int i=0; i<3; i++)
			delete[] yyval.trans.vect[i];
		    }

		    yyval.trans.type = new TransType[(yyval.trans.number+1)];
		    yyval.trans.vect[0] = new real_t[(yyval.trans.number+1)];
		    yyval.trans.vect[1] = new real_t[(yyval.trans.number+1)];
		    yyval.trans.vect[2] = new real_t[(yyval.trans.number+1)];

		    /* restore old values */
		    for (int i=0; i<yyval.trans.number; i++) {
		      yyval.trans.type[i] = savetype[i];
		      yyval.trans.vect[0][i] = savevect[0][i];
		      yyval.trans.vect[1][i] = savevect[1][i];
		      yyval.trans.vect[2][i] = savevect[2][i];
		    }

		    yyval.trans.hasRef = yyvsp[-2].trans.hasRef;
		    yyval.trans.inverse = yyvsp[-2].trans.inverse;
		    for (size_t i=0; i<4; ++i)
		      yyval.trans.ref[i] = yyvsp[-2].trans.ref[i];

		    delete[] savetype;
		    for (int i=0; i<3; i++)
		      delete [] savevect[i];
		    if (!strcmp (yyvsp[-1].str,"rotate")) {
		      yyval.trans.type[yyval.trans.number] = rotation;
		    } else if (!strcmp (yyvsp[-1].str,"translate")) {
		      yyval.trans.type[yyval.trans.number] = translation;
		    } else if (!strcmp (yyvsp[-1].str,"scale")) {
		      yyval.trans.type[yyval.trans.number] = scale;
		    } else {
		      std::cerr << "parse error unknown "
				<< yyvsp[-1].str << " check parsing in combo.y\n";
		    }
		    for (int i=0; i<3; i++)
		      yyval.trans.vect[i][yyval.trans.number] = yyvsp[0].vect[i];
		    
		    yyval.trans.number++;
		  }
		}
    break;

  case 19:
#line 372 "parse.pov.yy"
    {
		  if (execute) {
		    yyval.trans.number = yyvsp[-2].trans.number;
		    yyval.trans.type = new TransType[(yyval.trans.number)];
		    yyval.trans.vect[0] = new real_t[(yyval.trans.number)];
		    yyval.trans.vect[1] = new real_t[(yyval.trans.number)];
		    yyval.trans.vect[2] = new real_t[(yyval.trans.number)];

		    /* copy old modifier values */
		    for (int i=0; i<yyvsp[-2].trans.number; i++) {
		      yyval.trans.type[i] = yyvsp[-2].trans.type[i];
		      yyval.trans.vect[0][i] = yyvsp[-2].trans.vect[0][i];
		      yyval.trans.vect[1][i] = yyvsp[-2].trans.vect[1][i];
		      yyval.trans.vect[2][i] = yyvsp[-2].trans.vect[2][i];
		    }
		    if (yyvsp[-2].trans.number > 0) {
		      delete[] yyvsp[-2].trans.type; /* deallocate memory if needed */
		      for (int i=0; i<3; i++)
			delete[] yyvsp[-2].trans.vect[i];
		    }
		    yyval.trans.inverse = yyvsp[-2].trans.inverse;
		    yyval.trans.hasRef = yyvsp[-2].trans.hasRef;

		    for (size_t i=0; i<12; ++i)
		      yyval.trans.mat[i] = yyvsp[0].mat[i];

		    yyval.trans.type = new TransType[1];
		    yyval.trans.type[0] = matrix;

 		    yyval.trans.number=0;
 		  }
		}
    break;

  case 20:
#line 405 "parse.pov.yy"
    {
		  if (execute) {
		    yyval.trans.number = yyvsp[-1].trans.number;
		    yyval.trans.type = new TransType[(yyval.trans.number)];
		    yyval.trans.vect[0] = new real_t[(yyval.trans.number)];
		    yyval.trans.vect[1] = new real_t[(yyval.trans.number)];
		    yyval.trans.vect[2] = new real_t[(yyval.trans.number)];

		    /* copy old modifier values */
		    for (int i=0; i<yyvsp[-1].trans.number; i++) {
		      yyval.trans.type[i] = yyvsp[-1].trans.type[i];
		      yyval.trans.vect[0][i] = yyvsp[-1].trans.vect[0][i];
		      yyval.trans.vect[1][i] = yyvsp[-1].trans.vect[1][i];
		      yyval.trans.vect[2][i] = yyvsp[-1].trans.vect[2][i];
		    }
		    if (yyvsp[-1].trans.number > 0) {
		      delete[] yyvsp[-1].trans.type; /* deallocate memory if needed */
		      for (int i=0; i<3; i++)
			delete[] yyvsp[-1].trans.vect[i];
		    }
		    yyval.trans.hasRef = yyvsp[-1].trans.hasRef;

		    yyval.trans.inverse = not(yyvsp[-1].trans.inverse);
 		  }		  
		}
    break;

  case 21:
#line 433 "parse.pov.yy"
    {
		  if (execute) {

		    if (yyvsp[-1].trans.ref[3] == 0) { // means that the object is not transparent!
		      Vertex c(yyvsp[-4].vect[0], yyvsp[-4].vect[1], yyvsp[-4].vect[2]);
		      real_t& r = yyvsp[-2].val;
		      parsetrans& transformations = yyvsp[-1].trans;

		      Shape* s = new Sphere(c,r);
		      (*s).parseTransform(transformations);

		      if (yyvsp[-1].trans.inverse) {
			s = new Not(new Object(s));
		      }

		      Object O(s);
		      if (yyvsp[-1].trans.hasRef) {
			O.setReference(TinyVector<3>(yyvsp[-1].trans.ref[0],
						     yyvsp[-1].trans.ref[1],
						     yyvsp[-1].trans.ref[2]));
		      }

		      if (BoolOp) {
			OpStack.top().push_back(O);
		      } else {
			pScene->add(O);
		      }
		    }
		  }
		}
    break;

  case 22:
#line 464 "parse.pov.yy"
    {
		  if (execute) {

		    if (yyvsp[-1].trans.ref[3] == 0) { // means that the object is not transparent!
		      real_t& r1 = yyvsp[-4].val;
		      real_t& r2 = yyvsp[-2].val;
		      parsetrans& transformations = yyvsp[-1].trans;

		      Shape* s = new Torus(r1,r2);
		      (*s).parseTransform(transformations);

		      if (yyvsp[-1].trans.inverse) {
			s = new Not(new Object(s));
		      }

		      Object O(s);
 		      if (yyvsp[-1].trans.hasRef) {
			O.setReference(TinyVector<3>(yyvsp[-1].trans.ref[0],
						     yyvsp[-1].trans.ref[1],
						     yyvsp[-1].trans.ref[2]));
		      }

		      if (BoolOp) {
			OpStack.top().push_back(O);
		      } else {
			pScene->add(O);
		      }
		    }
		  }
		}
    break;

  case 23:
#line 495 "parse.pov.yy"
    {
		  if (execute) {
		    Vertex a(yyvsp[-4].vect[0], yyvsp[-4].vect[1], yyvsp[-4].vect[2]);
		    Vertex b(yyvsp[-2].vect[0], yyvsp[-2].vect[1], yyvsp[-2].vect[2]);
		    if (yyvsp[-1].trans.ref[3] == 0) { // means the object is not transparent
		      parsetrans& transformations = yyvsp[-1].trans;

		      Shape* s = new Cube(a,b);
		      (*s).parseTransform(transformations);

		      if (yyvsp[-1].trans.inverse) {
			s = new Not(new Object(s));
		      }

		      Object O(s);
		      if (yyvsp[-1].trans.hasRef) {
			O.setReference(TinyVector<3>(yyvsp[-1].trans.ref[0],
						     yyvsp[-1].trans.ref[1],
						     yyvsp[-1].trans.ref[2]));
		      }

		      /* put the cube in the list */
		      if (BoolOp) {
			OpStack.top().push_back(O);
		      } else {
			pScene->add(O);
		      }
		    } else {
		      SB = SceneBox(a, b);
		    }
		  }
		}
    break;

  case 24:
#line 528 "parse.pov.yy"
    {
		  if (execute) {
		    if (yyvsp[-1].trans.ref[3] == 0) { // means the object is not transparent
		      Vertex a(yyvsp[-6].vect[0], yyvsp[-6].vect[1], yyvsp[-6].vect[2]);
		      Vertex b(yyvsp[-4].vect[0], yyvsp[-4].vect[1], yyvsp[-4].vect[2]);
		      real_t radius = yyvsp[-2].val;
		      parsetrans& transformations = yyvsp[-1].trans;

		      Shape* s = new Cylinder(a,b,radius);
		      (*s).parseTransform(transformations);

		      if (yyvsp[-1].trans.inverse) {
			s = new Not(new Object(s));
		      }

		      Object O(s);
		      if (yyvsp[-1].trans.hasRef) {
			O.setReference( TinyVector<3>(yyvsp[-1].trans.ref[0],
						      yyvsp[-1].trans.ref[1],
						      yyvsp[-1].trans.ref[2]));
		      }

		      /* put the cylinder in the list */
		      if (BoolOp) {
			OpStack.top().push_back(O);
		      } else {
			pScene->add(O);
		      }
		    }
		  } 
		}
    break;

  case 25:
#line 560 "parse.pov.yy"
    {
		  if (execute) {
		    if (yyvsp[-3].trans.ref[3] == 0) { // means the object is not transparent
		      Vertex a(yyvsp[-8].vect[0], yyvsp[-8].vect[1], yyvsp[-8].vect[2]);
		      Vertex b(yyvsp[-4].vect[0], yyvsp[-4].vect[1], yyvsp[-4].vect[2]);
		      real_t radius1 = yyvsp[-6].val;
		      real_t radius2 = yyvsp[-2].val;
		      parsetrans& transformations = yyvsp[-1].trans;

		      Shape* s = new Cone(a,b,radius1, radius2);
		      (*s).parseTransform(transformations);

		      if (yyvsp[-3].trans.inverse) {
			s = new Not(new Object(s));
		      }

		      Object O(s);
		      if (yyvsp[-1].trans.hasRef) {
			O.setReference( TinyVector<3>(yyvsp[-1].trans.ref[0],
						      yyvsp[-1].trans.ref[1],
						      yyvsp[-1].trans.ref[2]));
		      }

		      /* put the cylinder in the list */
		      if (BoolOp) {
			OpStack.top().push_back(O);
		      } else {
			pScene->add(O);
		      }
		    }
		  }
		}
    break;

  case 26:
#line 593 "parse.pov.yy"
    {
		  if (execute) {

		    if (yyvsp[-1].trans.ref[3] == 0) { // means that the object is not transparent!
		      Vertex c(yyvsp[-4].vect[0], yyvsp[-4].vect[1], yyvsp[-4].vect[2]);
		      real_t& r = yyvsp[-2].val;
		      parsetrans& transformations = yyvsp[-1].trans;

		      Shape* s = new Plane(c,r);
		      (*s).parseTransform(transformations);

		      if (yyvsp[-1].trans.inverse) {
			s = new Not(new Object(s));
		      }

		      Object O(s);
		      if (yyvsp[-1].trans.hasRef) {
			O.setReference( TinyVector<3>(yyvsp[-1].trans.ref[0],
						      yyvsp[-1].trans.ref[1],
						      yyvsp[-1].trans.ref[2]));
		      }

		      if (BoolOp) {
			OpStack.top().push_back(O);
		      } else {
			pScene->add(O);
		      }
		    }
		  }
		}
    break;

  case 27:
#line 623 "parse.pov.yy"
    { 
		        if (execute) {
			  BoolOpStack.push(BoolOp);     // store previous context
			  OpStack.push(std::vector<Object>()); // start new vetor
		          BoolOp = true;
			}
	              }
    break;

  case 28:
#line 631 "parse.pov.yy"
    { 
		 if (execute) {
		   if (yyvsp[-1].trans.ref[3] == 0) { // means the object is not transparent
		     BoolOp = BoolOpStack.top(); // revert to previous context
		     BoolOpStack.pop();
		     Union* u = new Union();
		     for (size_t i=0; i<OpStack.top().size(); i++)
		       (*u).push_back(new Object(OpStack.top()[i]));
		     OpStack.pop();

		     parsetrans& transformations = yyvsp[-1].trans;
		     (*u).parseTransform(transformations);

		     Object O(u);
		     if (yyvsp[-1].trans.hasRef) {
		       O.setReference(TinyVector<3>(yyvsp[-1].trans.ref[0],
						    yyvsp[-1].trans.ref[1],
						    yyvsp[-1].trans.ref[2]));
		     }

		     if (BoolOp) {
		       OpStack.top().push_back(O);
		     } else {
		       pScene->add(O);
		     }
		   }
		 }
	      }
    break;

  case 29:
#line 659 "parse.pov.yy"
    { 
		        if (execute) {
			  BoolOpStack.push(BoolOp);     // store previous context
			  OpStack.push(std::vector<Object>()); // start new vetor
		          BoolOp = true;
			}
	              }
    break;

  case 30:
#line 667 "parse.pov.yy"
    { 
		 if (execute) {
		   if (yyvsp[-1].trans.ref[3] == 0) { // means the object is not transparent
		     BoolOp = BoolOpStack.top(); // revert to previous context
		     BoolOpStack.pop();
		     Intersection* I = new Intersection();

		     for (size_t i=0; i<OpStack.top().size(); i++)
		       (*I).push_back(new Object(OpStack.top()[i]));
		     OpStack.pop();

		     parsetrans& transformations = yyvsp[-1].trans;
		     (*I).parseTransform(transformations);

		     Object O(I);
		      if (yyvsp[-1].trans.hasRef) {
			O.setReference( TinyVector<3>(yyvsp[-1].trans.ref[0],
						      yyvsp[-1].trans.ref[1],
						      yyvsp[-1].trans.ref[2]));
		      }

		     if (BoolOp) {
		       OpStack.top().push_back(O);
		     } else {
		       pScene->add(O);
		     }
		   }
		 }
	      }
    break;

  case 31:
#line 696 "parse.pov.yy"
    { 
		        if (execute) {
			  BoolOpStack.push(BoolOp);     // store previous context
			  OpStack.push(std::vector<Object>()); // start new vetor
		          BoolOp = true;
			}
	              }
    break;

  case 32:
#line 704 "parse.pov.yy"
    {
		 if (execute) {
		   if (yyvsp[-1].trans.ref[3] == 0) { // means the object is not transparent
		     BoolOp = BoolOpStack.top(); // revert to previous context
		     BoolOpStack.pop();
		     Difference* d = new Difference();
	
		     for (size_t i=0; i<OpStack.top().size(); i++) {
		       (*d).push_back(new Object(OpStack.top()[i]));
		     }
		     OpStack.pop();

		     parsetrans& transformations = yyvsp[-1].trans;
		     (*d).parseTransform(transformations);

		     Object O(d);
		     if (yyvsp[-1].trans.hasRef) {
		       O.setReference(TinyVector<3>(yyvsp[-1].trans.ref[0],
						    yyvsp[-1].trans.ref[1],
						    yyvsp[-1].trans.ref[2]));
		     }

		     if (BoolOp) {
		       OpStack.top().push_back(O);
		     } else {
		       pScene->add(O);
		     }
		   }
		 }
	      }
    break;

  case 33:
#line 734 "parse.pov.yy"
    { // object is treated like an union limited to one object
#ifdef    __GNUC__
#warning REWORK OBJECT TREATMENT
#endif // __GNUC__
		        if (execute) {
			  BoolOpStack.push(BoolOp);     // store previous context
			  OpStack.push(std::vector<Object>()); // start new vetor
		          BoolOp = true;
			}
	              }
    break;

  case 34:
#line 745 "parse.pov.yy"
    { 
		 if (execute) {
		   if (yyvsp[-1].trans.ref[3] == 0) { // means the object is not transparent

		     BoolOp = BoolOpStack.top(); // revert to previous context
		     BoolOpStack.pop();
		     Union* u = new Union(); 
		     for (size_t i=0; i<OpStack.top().size(); i++)
		       (*u).push_back(new Object(OpStack.top()[i]));
		     OpStack.pop();

		     parsetrans& transformations = yyvsp[-1].trans;
		     (*u).parseTransform(transformations);

		     Object O(u);
		     if (yyvsp[-1].trans.hasRef) {
		       O.setReference(TinyVector<3>(yyvsp[-1].trans.ref[0],
						    yyvsp[-1].trans.ref[1],
						    yyvsp[-1].trans.ref[2]));
		     }

		     if (BoolOp) {
		       OpStack.top().push_back(O);
		     } else {
		       pScene->add(O);
		     }
		   }
		 }
	      }
    break;

  case 37:
#line 781 "parse.pov.yy"
    { yyval.val = yyvsp[0].val;         }
    break;

  case 38:
#line 782 "parse.pov.yy"
    { yyval.val = yyvsp[-2].val + yyvsp[0].val;    }
    break;

  case 39:
#line 783 "parse.pov.yy"
    { yyval.val = yyvsp[-2].val - yyvsp[0].val;    }
    break;

  case 40:
#line 784 "parse.pov.yy"
    { yyval.val = yyvsp[-2].val * yyvsp[0].val;    }
    break;

  case 41:
#line 785 "parse.pov.yy"
    { yyval.val = yyvsp[-2].val / yyvsp[0].val;    }
    break;

  case 42:
#line 786 "parse.pov.yy"
    { yyval.val = yyvsp[-1].val ;        }
    break;

  case 43:
#line 787 "parse.pov.yy"
    { yyval.val = -yyvsp[0].val;        }
    break;

  case 44:
#line 790 "parse.pov.yy"
    { yyval.integer = (fabs(yyvsp[0].val)>1E-6); }
    break;

  case 45:
#line 791 "parse.pov.yy"
    { yyval.integer = (yyvsp[-2].val > yyvsp[0].val);       }
    break;

  case 46:
#line 792 "parse.pov.yy"
    { yyval.integer = (yyvsp[-2].val < yyvsp[0].val);       }
    break;

  case 47:
#line 793 "parse.pov.yy"
    { yyval.integer = (yyvsp[-2].val >= yyvsp[0].val);      }
    break;

  case 48:
#line 794 "parse.pov.yy"
    { yyval.integer = (yyvsp[-2].val <= yyvsp[0].val);      }
    break;

  case 49:
#line 795 "parse.pov.yy"
    { yyval.integer = (yyvsp[-2].val == yyvsp[0].val);      }
    break;

  case 50:
#line 796 "parse.pov.yy"
    { yyval.integer = (yyvsp[-2].val != yyvsp[0].val);      }
    break;

  case 51:
#line 797 "parse.pov.yy"
    { yyval.integer = yyvsp[-2].integer && yyvsp[0].integer;        }
    break;

  case 52:
#line 798 "parse.pov.yy"
    { yyval.integer = yyvsp[-2].integer || yyvsp[0].integer;        }
    break;

  case 53:
#line 799 "parse.pov.yy"
    { yyval.integer = !(yyvsp[0].integer);           }
    break;

  case 54:
#line 800 "parse.pov.yy"
    { yyval.integer = yyvsp[-1].integer;              }
    break;

  case 55:
#line 807 "parse.pov.yy"
    { 
                                             yyval.mat[ 0] = yyvsp[-23].val;
					     yyval.mat[ 1] = yyvsp[-21].val;
					     yyval.mat[ 2] = yyvsp[-19].val;
                                             yyval.mat[ 3] = yyvsp[-17].val;
					     yyval.mat[ 4] = yyvsp[-15].val;
					     yyval.mat[ 5] = yyvsp[-13].val;
                                             yyval.mat[ 6] = yyvsp[-11].val;
					     yyval.mat[ 7] = yyvsp[-9].val;
					     yyval.mat[ 8] = yyvsp[-7].val;
                                             yyval.mat[ 9] = yyvsp[-5].val;
					     yyval.mat[10] = yyvsp[-3].val;
					     yyval.mat[11] = yyvsp[-1].val;
              }
    break;

  case 56:
#line 823 "parse.pov.yy"
    { 
                                             yyval.vect[0] = yyvsp[-5].val;
					     yyval.vect[1] = yyvsp[-3].val;
					     yyval.vect[2] = yyvsp[-1].val;
              }
    break;

  case 57:
#line 828 "parse.pov.yy"
    { // opposit vector
                                             yyval.vect[0] = - yyvsp[0].vect[0];
					     yyval.vect[1] = - yyvsp[0].vect[1];
					     yyval.vect[2] = - yyvsp[0].vect[2];	        
              }
    break;

  case 58:
#line 833 "parse.pov.yy"
    { // difference between 2 vectors
                                             yyval.vect[0] = yyvsp[-2].vect[0] - yyvsp[0].vect[0];
					     yyval.vect[1] = yyvsp[-2].vect[1] - yyvsp[0].vect[1];
					     yyval.vect[2] = yyvsp[-2].vect[2] - yyvsp[0].vect[2];
              }
    break;

  case 59:
#line 838 "parse.pov.yy"
    { // sum of 2 vectors
                                             yyval.vect[0] = yyvsp[-2].vect[0] + yyvsp[0].vect[0];
					     yyval.vect[1] = yyvsp[-2].vect[1] + yyvsp[0].vect[1];
					     yyval.vect[2] = yyvsp[-2].vect[2] + yyvsp[0].vect[2];
              }
    break;

  case 60:
#line 843 "parse.pov.yy"
    { // product by a scalar on right
                                             yyval.vect[0] = yyvsp[-2].vect[0] * yyvsp[0].val;
					     yyval.vect[1] = yyvsp[-2].vect[1] * yyvsp[0].val;
					     yyval.vect[2] = yyvsp[-2].vect[2] * yyvsp[0].val;
              }
    break;

  case 61:
#line 848 "parse.pov.yy"
    { // division by a scalar on right
                                             yyval.vect[0] = yyvsp[-2].vect[0] / yyvsp[0].val;
					     yyval.vect[1] = yyvsp[-2].vect[1] / yyvsp[0].val;
					     yyval.vect[2] = yyvsp[-2].vect[2] / yyvsp[0].val;
              }
    break;

  case 62:
#line 853 "parse.pov.yy"
    { // product by a scalar on left
                                             yyval.vect[0] = yyvsp[0].vect[0] * yyvsp[-2].val;
					     yyval.vect[1] = yyvsp[0].vect[1] * yyvsp[-2].val;
					     yyval.vect[2] = yyvsp[0].vect[2] * yyvsp[-2].val;
              }
    break;

  case 63:
#line 860 "parse.pov.yy"
    { 
                                             yyval.vect4[0] = yyvsp[-7].val;
					     yyval.vect4[1] = yyvsp[-5].val;
					     yyval.vect4[2] = yyvsp[-3].val;
					     yyval.vect4[3] = yyvsp[-1].val;
              }
    break;

  case 64:
#line 866 "parse.pov.yy"
    { // opposit vector4
  	                                   for (size_t i=0; i<4; ++i)
                                             yyval.vect4[i] = - yyvsp[0].vect4[i];
              }
    break;

  case 65:
#line 870 "parse.pov.yy"
    { // difference between 2 vector4s
  	                                   for (size_t i=0; i<4; ++i)
                                             yyval.vect4[i] = yyvsp[-2].vect4[i] - yyvsp[0].vect4[i];
              }
    break;

  case 66:
#line 874 "parse.pov.yy"
    { // sum of 2 vector4s
  	                                   for (size_t i=0; i<4; ++i)
                                             yyval.vect4[i] = yyvsp[-2].vect4[i] + yyvsp[0].vect4[i];
              }
    break;

  case 67:
#line 878 "parse.pov.yy"
    { // product by a scalar on right
  	                                   for (size_t i=0; i<4; ++i)
                                             yyval.vect4[i] = yyvsp[-2].vect4[i] * yyvsp[0].val;
              }
    break;

  case 68:
#line 882 "parse.pov.yy"
    { // division by a scalar on right
  	                                   for (size_t i=0; i<4; ++i)
                                             yyval.vect4[i] = yyvsp[-2].vect4[i] / yyvsp[0].val;
              }
    break;

  case 69:
#line 886 "parse.pov.yy"
    { // product by a scalar on left
  	                                   for (size_t i=0; i<4; ++i)
                                             yyval.vect4[i] = yyvsp[0].vect4[i] * yyvsp[-2].val;
              }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 2343 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 891 "parse.pov.yy"


     
void yyerror(char * s) {
   throw ErrorHandler("PARSED FILE",povlexer->lineno(),
		      stringify(s)+"'"+povlexer->YYText()+"' unexpected",
		      ErrorHandler::compilation);
}
void declarevar (char* name, char* val) {
  bool found = false;
  int varnum = 0;

  std::string expendval = val;
  // Substitute variables value in varname.
  expend(expendval);

  for (int i=0; i<nbvariables; ++i)
    if (strcmp(variables[i].name, name) == 0) {
      // The Variable's value is going to change
      found = true;
      delete [] variables[i].val.s;
      varnum = i;
    }
  if (!found) {
    // storing new variable
    varnum = nbvariables;
    nbvariables++;
    variables = (variable*)realloc(variables, nbvariables);
    variables[varnum].name = new char[strlen(name)+1];
    strcpy(variables[varnum].name, name);
  }
  // Affecting value
  variables[varnum].val.s = new char[expendval.size() + 1];
  strcpy(variables[varnum].val.s, expendval.c_str());
}

void expend(std::string& expendval) {
  int i=0;
  while (i<nbvariables) {
    std::string var = variables[i].name;
    std::string val = variables[i].val.s;
    int begining = expendval.find_first_of(variables[i].name);
    if (begining >= 0) {
      bool replace = true;
      if (begining > 0) {
	replace = !isalnum(expendval[begining-1]);
      }
      replace = (replace) && isalnum(expendval[begining+var.size()]);
      if (replace) {

	std::stringstream tempstr;
	for (int i=0; i<begining; i++)
	  tempstr << expendval[i];
	tempstr << val;
	for (size_t i=begining+var.size()-1; i < expendval.size(); i++)
	  tempstr << expendval[i];
	tempstr << std::ends;

	expendval = tempstr.str();
      }

    } else {
      i++;
    }
  }
}



