//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2001, 2002, 2003 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: StreamCenter.cpp,v 1.4 2004/04/13 09:26:27 delpinux Exp $

#include <StreamCenter.hpp>
#include <fstream>

//! Null stream.
class StreamCenter__NullStream : public std::streambuf {};

StreamCenter::StreamCenter()
  : __debugLevel(1),
    __nullStream(new StreamCenter__NullStream),
    __log(new std::ofstream("ff3d.log")),
    __out(&std::cout),
    __err(&std::cerr)
{
  if (not(*__log)) {
    // fferr() function is not already available, must use std::cerr
    std::cerr << "warning: cannot open 'ff3d.log'\n";
    delete __log;
    __log = &__nullStream;
  }
}
